<?php
/**
 * filtrowanie w panelu listy postów
 *
 * Dodaj zawartość tego pliku na końcu pliku functions.php w używanym temacie.
 *
 * W celu wyboru pola zmień 'level' w definicji 'IWORKS_FIELD_NAME'
 *
 * Opis działania: http://iworks.pl/2011/03/02/wordpress-filtrowanie-w-panelu-listy-postow/
 *
 */

define('IWORKS_FIELD_NAME', 'level');

add_filter( 'parse_query', 'iworks_level_filter' );
add_action( 'restrict_manage_posts', 'iworks_level_restrict_manage_posts' );

function iworks_level_filter( $query )
{
    global $pagenow;
    if ( is_admin() && $pagenow=='edit.php' && isset($_GET[IWORKS_FIELD_NAME]) && $_GET[IWORKS_FIELD_NAME] != '') {
        $query->query_vars['meta_query'] = array (
            array (
                'key'     => IWORKS_FIELD_NAME,
                'value'   => $_GET[IWORKS_FIELD_NAME],
                'compare' => 'IN',
                'type'    => 'DECIMAL'
            )
        );
    }
}

function iworks_level_restrict_manage_posts()
{
    global $wpdb;
    $sql = 'SELECT DISTINCT meta_value FROM '.$wpdb->postmeta.' WHERE meta_key = \'level\' ORDER BY 1';
    $fields = $wpdb->get_results($sql, ARRAY_N);
?>
<select name="IWORKS_FIELD_NAME">
<option value=""><?php _e('Show all levels', 'iworks'); ?></option>
<?php
    $current = isset($_GET[IWORKS_FIELD_NAME])? $_GET[IWORKS_FIELD_NAME]:'';
    foreach ($fields as $field) {
        printf
            (
                '<option value="%s"%s>%s</option>',
                $field[0],
                $field[0] == $current? ' selected="selected"':'',
                $field[0]
            );
    }
?>
</select>
<?php
}

?>
